#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include "err.h"

int main ()
{
  register int i;

  if (setpgrp() == -1)  /* set new process group */
    syserr("setpgrp");

  for (i = 0; i < 10; i++)
    switch (fork()) {
      case -1:
        syserr("fork");
      case 0: 	    /* child process */
        if (i & 1)  /* for odd number - create new group */
	  if (setpgrp() == -1)
	    syserr("setpgrp2");
        printf("pid = %d pgrp = %d\n", getpid(), getpgrp());
        if (i & 1)  /* for odd numer - wait 15 seconds */
	  sleep(15);
	else
	  pause();  /* for even number - wait for signal from parent */
	return 0;
    }

  sleep(5); /* give time for child processes to start */
  
  if (kill(0, SIGINT) == -1) /* kill'em all (only even one) */
    syserr("kill");
  return 0;
}  /*main*/

