#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include "err.h"
#include "systemv.h"

void catchsignal(int nr)  /* nr is the number of caught signal */
{
  fprintf(stderr,"PID %d caught signal %d\n", getpid(), nr);
  if (signal(nr, catchsignal) == SIG_ERR)
    syserr("signal1");
}

int main()
{
   int ppid;

   if (signal(SIGINT, catchsignal) == SIG_ERR)
     syserr("signal2");
   if (signal(SIGQUIT, catchsignal) == SIG_ERR)
     syserr("signal3");

   switch(fork()) {
     case -1:
       syserr("fork");
     case 0: 
       ppid = getppid();
       for (;;)  /* send SIGINT to parent process */
         if (kill(ppid, SIGINT) == -1)
           syserr("kill");
   }

   /* lower priority - higher chance to get race conditions */
   if (nice (100) == -1)
     syserr("nice");

   for (;;);
}  /*main*/
