#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include "err.h"
#include "systemv.h"

void outoftime (int nr) {}

int t_read(int fd, char *buf, int bufsize, int timeout)
{
  int ret;
  void (*handler)(int); /* variable to remember the oryginal signal handler */
 
  if ((handler = signal(SIGALRM, outoftime)) == SIG_ERR)
  			/* empty signal handler */
    syserr("signal1");

  alarm(timeout);       /* start timer */
  ret = read(fd, buf, bufsize); /* read from keyboard */
  alarm(0);		/* stop timer */

  if (signal(SIGALRM, handler) == SIG_ERR)
  			/* set oryginal signal handler */
    syserr("signal2");  

  return ret;
}

int main() 
{
  char buff[100];
  int res;

  setvbuf(stdout, 0, _IONBF, 0);
  		       /* unset buffering for stdout */
  
  while(1) {
    printf("enter string: ");
    switch (res = t_read(0, buff, sizeof(buff), 5)) {
      case -1:
        if (errno == EINTR) {
          printf("time out!\n");
          break;
        } else
          syserr("t_read");
      case 0:
	return 0;
      default:
        buff[res - 1] = '\0';   /* end of string instead of end of line */
        printf("entered string is: %s\n", buff);
    }
  }
}
